=== debian/changelog ===
ogre (1.7.4-3) unstable; urgency=low

  * Install /usr/share/OGRE-*/*.cfg files in the samples binary package instead
    of an arch-independent one, so it includes the correct path for plugins for
    each architecture (Closes: #663502)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 12 Mar 2012 19:34:12 +0000

ogre (1.7.4-2) unstable; urgency=low

  * Test for existence of directories /etc/OGRE* before attempting to remove
    them in {pre,post}{inst,rm} scripts
  * Declaring pre-dependency on dpkg (>= 1.15.7.2~) because of the use of
    dpkg-maintscript-helper
  * debian/copyright format set to format-1.0 (with appropriate URL)
  * Fix short description and priority of the sample packages

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 04 Mar 2012 23:44:09 +0000

ogre (1.7.4-1) unstable; urgency=low

  * New upstream release
    - Change names of relevant packages with 1.7.3 for 1.7.4
  * Bump Standards-Version to 3.9.3 (no changes needed)
  * Enable building and installing the samples, including source code
    - Create new packages: ogre-samples, -data and -dbg
    - Add Build-Depends on libois-dev
    - Add debian/patches/change_sample_cfg_path.patch to make SampleBrowser be
      able to detect the plugins installed in the system, especially the
      Renderer, without which it cannot start.
  * Add "dpkg-maintscript-helper rm_conffile /etc/OGRE/plugins.cfg" also in
    libogre-$(VERSION).postinst and .postrm (not only .preinst), to try to
    remove unmodified versions of the file from previous package revisions.
    Thanks again to Sam Morris, hopefully the bug is properly fixed this time
    (Closes: #656997).
    - Do the same for /etc/OGRE-1.7.3/plugins.cfg shipped in 1.7.3-5
  * Remove wrongly used "Multi-Arch: same" in -dev package, one of the files
    shipped is actually different in some architectures due to endian-ness
    differences (Closes: #658659).  Thanks Jakub Wilk.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 27 Feb 2012 14:42:45 +0000
